--	Gore Extension script

--	(made by Alistaire)

--[[

CONFIG FILE IS CALLED GE_Config.lua!

--]]

dofile('sys/lua/GE_Config.lua')

function A()
	local c = {}
	for i = 1, 32 do
		c[i] = 0
	end
	return c
end

function B()
	local c = {}
	for i = 1, 32 do
		c[i] = {}
		for i2 = 1, 32 do
			c[i][i2] = 0
		end
	end
	return c
end

P 				= 		'gfx/GoreExtension/'
PHB				=		'gfx/GoreExtension/Hpbar/'

GE_foot 		= 		0
GE_val 			= 		0

G 				= 		{}
G2 				= 		{}
GE_img 			= 		{}
GE_img2 		= 		{}
GE_mouse		=		{}

GE_att 			= 		A()
GE_bar 			= 		A()
GE_diex 		= 		A()
GE_diey 		= 		A()
GE_dmg 			= 		A()
GE_flash 		= 		A()
GE_highest		=		A()
GE_ht 			= 		A()
GE_knife		=		A()
GE_knifeimg		=		A()
GE_mode 		= 		A()
GE_overlay 		= 		A()
GE_points		=		A()
GE_scope 		= 		A()
GE_splash 		= 		A()
GE_stage		=		A()
GE_walkflash 	= 		A()
GE_worn1		=		A()
GE_worn2		=		A()

GE_pldmg		=		B()

G[1] 			= 		{1, 2, 4, 5, 6, 20, 21, 23, 46, 85, 88}
G[2] 			= 		{3, 11, 22, 24, 32, 34, 39, 69, 78, 91}
G[3] 			= 		{10, 30, 33, 38, 49}
G[4] 			= 		{31, 36, 37, 40, 45, 47, 48, 90}
G[5] 			= 		{35}
G2[1] 			= 		{1, 2, 3, 4, 5, 6}
G2[2] 			= 		{10, 11}
G2[3] 			= 		{20, 21, 22, 23, 24}
G2[4] 			= 		{30, 32, 38, 39, 40, 90, 91}
G2[5] 			= 		{31, 33, 34, 35, 36, 37}
G2[6] 			= 		{45, 47, 48, 49}

GE_weapons		=		{45, 47, 48, 46, 49, 90, 40, 35, 34, 37, 36, 91, 31, 33, 32, 30, 39, 38, 10, 11, 22, 20, 24, 21, 23, 3, 6, 5, 1, 2, 4, 85, 76, 89, 69, 78, 87, 77, 72, 73, 51, 86, 75, 50}
GE_kills		=		{5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 4, 4, 4, 4, 4, 3, 3, 3, 3, 3, 3, 5, 4, 4, 4, 3, 3, 3, 3, 3, 2, 2, 2, 1}

addhook('always',		'GE_always')
addhook('attack', 		'GE_attack')
addhook('attack2', 		'GE_attack2')
addhook('clientdata',	'GE_clientdata')
addhook('collect', 		'GE_collect')
addhook('die',			'GE_die')
addhook('hit', 			'GE_hit')
addhook('kill', 		'GE_kill')
addhook('move', 		'GE_move')
addhook('movetile', 	'GE_movetile')
addhook('say', 			'GE_say')
addhook('second', 		'GE_second')
addhook('select', 		'GE_select')
addhook('spawn', 		'GE_spawn')
addhook('startround',	'GE_startround')

function GE_always()
	reqcld(0, 2)
end

function GE_attack(id)
	function S(p)
		parse('shake '..id..' '..p)
	end
	local z = player(id, 'weapontype')
	local y = GE_mode[id]
	if GE_attflares == 1 then
		for i = 1, 6 do
			if GE_contains(G2[i], z) then
				if i == 1 then
					if z == 1 then
						if y == 1 then
							GE_att[id] = image(P..'2.png', 0, 1, 1)
						else
							GE_att[id] = image(P..'3.png', 0, 1, 1)
						end
					elseif z == 2 then
						if y == 1 then
							GE_att[id] = image(P..'4.png', 0, 1, 1)
						else
							GE_att[id] = image(P..'3.png', 0, 1, 1)
						end
					elseif z == 3 then
						GE_att[id] = image(P..'1.png', 0, 1, 1)
					else
						GE_att[id] = image(P..'3.png', 0, 1, 1)
					end
				elseif i == 2 then
					GE_att[id] = image(P..'5.png', 0, 1, 1)
				elseif i == 3 then
					GE_att[id] = image(P..'6.png', 0, 1, 1)
				elseif i == 4 then
					if z == 32 then
						if y == 1 then
							GE_att[id] = image(P..'2.png', 0, 1, 1)
						else
							GE_att[id] = image(P..'3.png', 0, 1, 1)
						end
					elseif z == 40 or z == 90 then
						GE_att[id] = image(P..'3.png', 0, 1, 1)
					else
						GE_att[id] = image(P..'7.png', 0, 1, 1)
					end
				elseif i == 5 then
					if z == 34 or z == 35 then
						GE_att[id] = image(P..'3.png', 0, 1, 1)
					else
						GE_att[id] = image(P..'7.png', 0, 1, 1)
					end
				elseif i == 6 then
					if z == 45 then
						GE_att[id] = image(P..'45.png', 0, 1, 1)
						GE_flash[id] = image(P..'45f.png', 0, 1, 1)
						if y == 0 then
							imagecolor(GE_att[id], 0, 255, 0)
							imagecolor(GE_flash[id], 0, 255, 0)
						elseif y == 1 then
							imagecolor(GE_att[id], 255, 0, 0)
							imagecolor(GE_flash[id], 255, 0, 0)
						elseif y == 2 then
							imagecolor(GE_att[id], 255, 255, 0)
							imagecolor(GE_flash[id], 255, 255, 0)
						elseif y == 3 then
							imagecolor(GE_att[id], 0, 0, 255)
							imagecolor(GE_flash[id], 0, 0, 255)
						end
						imagepos(GE_flash[id], player(id, 'x'), player(id, 'y'), player(id, 'rot'))
						tween_alpha(GE_flash[id], 1000, 0.0)
						timer(1000, 'freeimage', GE_flash[id])
					else
					end
				else
				end
				if z ~= 45 then
					timer(200, 'freeimage', GE_att[id])
					tween_alpha(GE_att[id], 200, 0.0)
				else
					timer(1000, 'freeimage', GE_att[id])
					tween_alpha(GE_att[id], 1000, 0.0)
				end
				imagepos(GE_att[id], player(id, 'x'), player(id, 'y'), player(id, 'rot')) 
			end
		end
	end
	if GE_wpnshake == 1 then
		for i = 1, 5 do
			if GE_contains(G[i], z) then
				if player(id, 'health') <= player(id, 'maxhealth') / 3.5 then
					if i == 1 then 			S(2)
					elseif i == 2 then 		S(3)
					elseif i == 3 then 		S(4)
					elseif i == 4 then 		S(5)
					elseif i == 5 then 		S(6)
					end
				end
			end
		end
	end
end

function GE_attack2(id, mode)
	GE_mode[id] = mode
end

function GE_clientdata(id, mode, data1, data2)
	if mode == 2 then
		GE_mouse[id] = {data1, data2}
	end
end

function GE_collect(id, iid, mode)
	GE_mode[id] = mode
	if GE_hpbar > 0 then
		if iid == 64 or 65 then
			GE_hudupdate(id)
		end
	end
end

function GE_contains(a, b)
	for _, c in pairs(a) do
		if c == b then
			return true
		end
	end
	return false
end

function GE_die(victim)
	if GE_wornweapons == 1 then
		freeimage(GE_worn1[victim]) freeimage(GE_worn2[victim])
	end
	if GE_hpbar > 0 then
		freeimage(GE_bar[victim])
		freeimage(GE_overlay[victim])
	end
end

function GE_erase()
	local a = GE_fadetime
	local d = GE_fadesettings
	GE_val = GE_val + 1
	if GE_maxval == 0 then
	elseif GE_val > GE_maxval then
		if d == 1 then
			tween_alpha(GE_img[GE_val - GE_maxval], a, 0.0)
			timer(a, 'freeimage', GE_img[GE_val - GE_maxval])
		elseif d == 0 then
			freeimage(GE_img[GE_val - GE_maxval])
		end
	end
end

function GE_erase2()
	local a = GE_fadetime
	local b = GE_foot
	local c = GE_footmax
	local d = GE_fadesettings
	GE_foot = GE_foot + 1
	if GE_footmax == 0 then
	elseif b > c then
		if d == 1 then
			tween_alpha(GE_img2[b - c], a, 0.0)
			timer(a, 'freeimage', GE_img2[b - c])
		elseif d == 0 then
			freeimage(GE_img2[b - c])
		end
	end
end

function GE_hit(id, source, weapon, hpdmg, apdmg, rawdmg)
	if GE_hpbar > 0 then
		GE_hudupdate(id, hpdmg)
	end
	local a = GE_fadetime
	local b = hpdmg + apdmg
	local d = GE_fadesettings
	local f = player(id, 'weapon')
	local g = player(id, 'tilex')
	local h = player(id, 'tiley')
	local i = g * 32 + 16
	local j = h * 32 + 16
	local k = GE_diex[id]
	local l = GE_diey[id]
	local m = player(source, 'rot')
	local y = GE_mode[source]
	local z = weapon
	if player(id, 'team') ~= player(source, 'team') then
		if b <= 10 then GE_dmg[id] = math.random(1, 2)
		elseif b <= 15 then GE_dmg[id] = math.random(3, 4)
		elseif b <= 20 then GE_dmg[id] = 5
		elseif b <= 30 then GE_dmg[id] = 6
		elseif b <= 50 then GE_dmg[id] = 7
		else GE_dmg[id] = math.random(8, 9)
		end
		GE_img[GE_val] = image(P..'H'..GE_dmg[id]..'.png', k, l, 0)
		imagepos(GE_img[GE_val], k + math.random(-8, 8), l + math.random(-8, 8), math.random(0, 360))
		imagecolor(GE_img[GE_val], math.random(200, 255), 0, 0)
		if d == 2 then
			tween_alpha(GE_img[GE_val], a, 0.0)
			timer(a, 'freeimage', GE_img[GE_val])
		elseif d ~= -1 then
			GE_erase()
		end
		if GE_mgore == 1 then
			GE_randomimg(GE_val, id)
			GE_randomimg(GE_val, id)
		end
		if GE_limbs == 1 then	
			if z == 85 then
				GE_img[GE_val] = image(P..'P'..math.random(1, 3)..'.png', k, l, 0)
				imagepos(GE_img[GE_val], k + math.random(-16, 16), l + math.random(-16, 16), player(source, 'rot'))
				if d == 2 then
					tween_alpha(GE_img[GE_val], a, 0.0)
					timer(a, 'freeimage', GE_img[GE_val])
				elseif d ~= -1 then
					GE_erase()
				end
			end
		end
		if GE_hitsplashes == 1 then
			for i = 1, 5 do
				if GE_contains(G2[i], z) then
					if i == 1 then
						GE_ht[id] = image(P..''..math.random(5, 6)..'h.png', 0, 1, 1)
					elseif i == 2 then
						GE_ht[id] = image(P..''..math.random(1, 2)..'h.png', 0, 1, 1)
					elseif i == 3 then
						GE_ht[id] = image(P..''..math.random(4, 6)..'h.png', 0, 1, 1)
					elseif i == 4 then
						GE_ht[id] = image(P..''..math.random(6, 7)..'h.png', 0, 1, 1)
					elseif i == 5 then
						GE_ht[id] = image(P..''..math.random(8, 9)..'h.png', 0, 1, 1)
					elseif z == 45 then
						GE_ht[id] = image(P..'10h.png', 0, 1, 1)
					elseif z == 251 then
						GE_ht[id] = image(P..'11h.png', 0, 1, 1)
					end
				end
			end
		end
		if z == 45 then
			GE_splash[id] = image(P..'Splash2.png', 320, 240, 2, id) 		imagepos(GE_ht[id], player(id, 'x'), player(id, 'y'), player(source, 'rot'))
			if y == 0 then
				imagecolor(GE_ht[id], 0, 255, 0) 							imagecolor(GE_splash[id], 0, 255, 0)
			elseif y == 1 then
				imagecolor(GE_ht[id], 255, 0, 0) 							imagecolor(GE_splash[id], 255, 0, 0)
			elseif y == 2 then
				imagecolor(GE_ht[id], 255, 255, 0) 							imagecolor(GE_splash[id], 255, 255, 0)
			elseif y == 3 then
				imagecolor(GE_ht[id], 0, 0, 255) 							imagecolor(GE_splash[id], 0, 0, 255)
			end
			tween_alpha(GE_ht[id], 1000, 0.0) 								tween_alpha(GE_splash[id], 1000, 0.0)
			timer(1000, 'freeimage', GE_ht[id]) 							timer(1000, 'freeimage', GE_splash[id])
		elseif z > 250 then
		else
			GE_splash[id] = image(P..'Splash.png', 320, 240, 2, id) 		imagepos(GE_ht[id], player(id, 'x'), player(id, 'y'), player(source, 'rot')) 
			imagecolor(GE_ht[id], math.random(200, 255), 0, 0) 				imagecolor(GE_splash[id], math.random(200, 255), 0, 0)
			tween_alpha(GE_ht[id], 200, 0.0) 								tween_alpha(GE_splash[id], 1000, 0.0)
			timer(200, 'freeimage', GE_ht[id]) 								timer(1000, 'freeimage', GE_splash[id])
			if GE_hitsmoke == 1 then
				for i = 1, 5 do
					if GE_contains(G2[i], z) then
						if i == 1 then
							parse('effect \"colorsmoke\" '..k + math.random(-1, 1)..' '..l + math.random(-1, 1)..' 1 1 '..math.random(200, 255)..' 0 0')
						elseif i == 2 then
							parse('effect \"colorsmoke\" '..k + math.random(-3, 3)..' '..l + math.random(-3, 3)..' 5 5 '..math.random(200, 255)..' 0 0')
						elseif i == 3 then
							parse('effect \"colorsmoke\" '..k + math.random(-1, 1)..' '..l + math.random(-1, 1)..' 2 1 '..math.random(200, 255)..' 0 0')
						elseif i == 4 then
							parse('effect \"colorsmoke\" '..k + math.random(-2, 2)..' '..l + math.random(-2, 2)..' 2 2 '..math.random(200, 255)..' 0 0')
						elseif i == 5 then
							parse('effect \"colorsmoke\" '..k + math.random(-2, 2)..' '..l + math.random(-2, 2)..' 4 3 '..math.random(200, 255)..' 0 0')
						end
					end
				end
			end
		end
		if GE_hitshake == 1 then
			for i = 1, 5 do
				if GE_contains(G[i], z) then
					if player(id, 'health') > player(id, 'maxhealth') / 3.5 then
						if i == 1 then
							parse('shake '..id..' 2')
						elseif i == 2 then
							parse('shake '..id..' 3')
						elseif i == 3 then
							parse('shake '..id..' 4')
						elseif i == 4 then
							parse('shake '..id..' 5')
						elseif i == 5 then
							parse('shake '..id..' 10')
						end
					else
						if i == 1 then
							parse('shake '..id..' 4')
						elseif i == 2 then
							parse('shake '..id..' 5')
						elseif i == 3 then
							parse('shake '..id..' 6')
						elseif i == 4 then
							parse('shake '..id..' 7')
						elseif i == 5 then
							parse('shake '..id..' 20')
						end
					end
				end
			end
		end
		if GE_mode[id] > 0 and (f == 31 or (f >= 33 and f <= 37)) then
			GE_scope[id] = image(P..'Scope.png', 320, 240, 2, id)
			imagecolor(GE_scope[id], math.random(200, 255), 0, 0)
			tween_alpha(GE_scope[id], 800, 0.0)
			timer(800, 'freeimage', GE_scope[id])
		end
		if z == 50 then
			if GE_knife[source] == 0 then
				GE_knifeimg[source] = image(P..'F'..math.random(1, 4)..'.png', GE_diex[source], GE_diey[source], source + 200)
				imagecolor(GE_knifeimg[source], math.random(200, 255), 0, 0)
				imagealpha(GE_knifeimg[source], 0.7)
				GE_knife[source] = 1
			else
			end
		end
		if GE_wgore == 1 then
			if m > 22.5 and m < 67.5 then
				if tile(g + 1, h - 1, 'wall') == true then
					if tile(g + 1, h, 'wall') == true then
						if tile(g, h - 1, 'wall') == true then
							GE_img[GE_val] = image(P..'WI2.png', i, j - 32, 1)
							imagepos(GE_img[GE_val], i + 16, j - 16, 90)
						else
							GE_img[GE_val] = image(P..'WS2.png', i + 16, j - 16, 1)
							imagepos(GE_img[GE_val], i + 16, j - 16, 90)
						end
					else
						if tile(g, h - 1, 'wall') == true then
							GE_img[GE_val] = image(P..'WS2.png', i + 16, j - 16, 1)
						else
							GE_img[GE_val] = image(P..'WC2.png', i + 32, j - 32, 1)
							imagepos(GE_img[GE_val], i + 32, j - 32, 90)
						end
					end
					imagecolor(GE_img[GE_val], math.random(200, 255), 0, 0)
					GE_erase()
				else
					if tile(g + 1, h, 'wall') == true then
						if tile(g, h - 1, 'wall') == true then
							GE_img[GE_val] = image(P..'WI1.png', i - 16, j - 48, 1)
							imagepos(GE_img[GE_val], i + 16, j - 16, 90)
						else
							GE_img[GE_val] = image(P..'WS1.png', i, j - 32, 1)
							imagepos(GE_img[GE_val], i + 32, j, 90)
						end
						imagecolor(GE_img[GE_val], math.random(200, 255), 0, 0)
						GE_erase()
					else
						if tile(g, h - 1, 'wall') == true then
							GE_img[GE_val] = image(P..'WS1.png', i, j - 32, 1)
							imagecolor(GE_img[GE_val], math.random(200, 255), 0, 0)
							GE_erase()
						else
						end
					end
				end
			elseif m > 67.5 and m < 112.5 then
				if tile(g + 1, h, 'wall') == true then
					GE_img[GE_val] = image(P..'WS1.png', i + 32, j, 1)
					imagepos(GE_img[GE_val], i + 32, j, 90)
					imagecolor(GE_img[GE_val], math.random(200, 255), 0, 0)
					GE_erase()
				end
			elseif m > 112.5 and m < 157.5 then
				if tile(g + 1, h + 1, 'wall') == true then
					if tile(g, h + 1, 'wall') == true then
						if tile(g + 1, h, 'wall') == true then
							GE_img[GE_val] = image(P..'WI2.png', i + 16, j + 16, 1)
							imagepos(GE_img[GE_val], i + 16, j + 16, 180)
						else
							GE_img[GE_val] = image(P..'WS2.png', i + 32, j + 32, 1)
							imagepos(GE_img[GE_val], i + 16, j + 16, 180)
						end
					else
						if tile(g + 1, h, 'wall') == true then
							GE_img[GE_val] = image(P..'WS2.png', i + 32, j + 32, 1)
							imagepos(GE_img[GE_val], i + 16, j + 16, 90)
						else
							GE_img[GE_val] = image(P..'WC2.png', i + 32, j + 32, 1)
							imagepos(GE_img[GE_val], i + 32, j + 32, 180)
						end
					end
					imagecolor(GE_img[GE_val], math.random(200, 255), 0, 0)
					GE_erase()
				else
					if tile(g, h + 1, 'wall') == true then
						if tile(g + 1, h, 'wall') == true then
							GE_img[GE_val] = image(P..'WI1.png', i + 16, j + 16, 1)
							imagepos(GE_img[GE_val], i + 16, j + 16, 180)
						else
							GE_img[GE_val] = image(P..'WS1.png', i + 32, j + 32, 1)
							imagepos(GE_img[GE_val], i, j + 32, 180)
						end
						imagecolor(GE_img[GE_val], math.random(200, 255), 0, 0)
						GE_erase()
					else
						if tile(g + 1, h, 'wall') == true then
							GE_img[GE_val] = image(P..'WS1.png', i + 32, j + 32, 1)
							imagepos(GE_img[GE_val], i + 32, j, 90)
							imagecolor(GE_img[GE_val], math.random(200, 255), 0, 0)
							GE_erase()
						else
						end
					end
				end
			elseif m > 157.5 or m < -157.5 then
				if tile(g, h + 1, 'wall') == true then
					GE_img[GE_val] = image(P..'WS1.png', i, j + 32, 1)
					imagepos(GE_img[GE_val], i, j + 32, 180)
					imagecolor(GE_img[GE_val], math.random(200, 255), 0, 0)
					GE_erase()
				end
			elseif m > -157.5 and m < -112.5 then
				if tile(g - 1, h + 1, 'wall') == true then
					if tile(g, h + 1, 'wall') == true then
						if tile(g - 1, h, 'wall') == true then
							GE_img[GE_val] = image(P..'WI2.png', i - 48, j + 16, 1)
							imagepos(GE_img[GE_val], i - 16, j + 16, 270)
						else
							GE_img[GE_val] = image(P..'WS2.png', i - 32, j + 32, 1)
							imagepos(GE_img[GE_val], i - 16, j + 16, 180)
						end
					else
						if tile(g - 1, h, 'wall') == true then
							GE_img[GE_val] = image(P..'WS2.png', i - 32, j + 32, 1)
							imagepos(GE_img[GE_val], i - 16, j + 16, 270)
						else
							GE_img[GE_val] = image(P..'WC2.png', i - 32, j + 32, 1)
							imagepos(GE_img[GE_val], i - 32, j + 32, 270)
						end
					end
					imagecolor(GE_img[GE_val], math.random(200, 255), 0, 0)
					GE_erase()
				else
					if tile(g, h + 1, 'wall') == true then
						if tile(g - 1, h, 'wall') == true then
							GE_img[GE_val] = image(P..'WI1.png', i - 48, j + 16, 1)
							imagepos(GE_img[GE_val], i - 16, j + 16, 270)
						else
							GE_img[GE_val] = image(P..'WS1.png', i - 32, j + 32, 1)
							imagepos(GE_img[GE_val], i, j + 32, 180)
						end
						imagecolor(GE_img[GE_val], math.random(200, 255), 0, 0)
						GE_erase()
					else
						if tile(g - 1, h, 'wall') == true then
							GE_img[GE_val] = image(P..'WS1.png', i - 32, j + 32, 1)
							imagepos(GE_img[GE_val], i - 32, j, 270)
							imagecolor(GE_img[GE_val], math.random(200, 255), 0, 0)
							GE_erase()
						else
						end
					end
				end
			elseif m > -112.5 and m < -67.5 then
				if tile(g - 1, h, 'wall') == true then
					GE_img[GE_val] = image(P..'WS1.png', i - 32, j, 1)
					imagepos(GE_img[GE_val], i - 32, j, 270)
					imagecolor(GE_img[GE_val], math.random(200, 255), 0, 0)
					GE_erase()
				end
			elseif m > -67.5 and m < -22.5 then
				if tile(g - 1, h - 1, 'wall') == true then
					if tile(g, h - 1, 'wall') == true then
						if tile(g - 1, h, 'wall') == true then
							GE_img[GE_val] = image(P..'WI2.png', i - 16, j - 16, 1)
						else
							GE_img[GE_val] = image(P..'WS2.png', i - 16, j - 16, 1)
						end
					else
						if tile(g - 1, h, 'wall') == true then
							GE_img[GE_val] = image(P..'WS2.png', i - 32, j - 32, 1)
							imagepos(GE_img[GE_val], i - 16, j - 16, 270)
						else
							GE_img[GE_val] = image(P..'WC2.png', i - 32, j - 32, 1)
						end
					end
					imagecolor(GE_img[GE_val], math.random(200, 255), 0, 0)
					GE_erase()
				else
					if tile(g, h - 1, 'wall') == true then
						if tile(g - 1, h, 'wall') == true then
							GE_img[GE_val] = image(P..'WI1.png', i - 16, j - 16, 1)
						else
							GE_img[GE_val] = image(P..'WS1.png', i, j - 32, 1)
						end
						imagecolor(GE_img[GE_val], math.random(200, 255), 0, 0)
						GE_erase()
					else
						if tile(g - 1, h, 'wall') == true then
							GE_img[GE_val] = image(P..'WS1.png', i - 32, j - 32, 1)
							imagepos(GE_img[GE_val], i - 32, j, 270)
							imagecolor(GE_img[GE_val], math.random(200, 255), 0, 0)
							GE_erase()
						else
						end
					end
				end
			elseif m > -22.5 and m < 22.5 then
				if tile(g, h - 1, 'wall') == true then
					GE_img[GE_val] = image(P..'WS1.png', i, j - 32, 1)
					imagecolor(GE_img[GE_val], math.random(200, 255), 0, 0)
					GE_erase()
				end
			end
		end
		if GE_assists > 0 then
			if hpdmg >= player(id, 'health') then
				for i = 1, 32 do
					for i2 = 1, 32 do
						if i ~= source and i2 ~= source then
							if GE_pldmg[i][id] > GE_pldmg[i2][id] then
								if GE_pldmg[i][id] > GE_highest[id] then
									GE_highest[id] = i
								end
							end
						end
					end
				end
				if GE_highest[id] ~= 0 then
					if GE_assists < 3 then
						msg('100100100'..player(GE_highest[id], 'name')..' has assisted '..player(source, 'name')..' in killing '..player(id, 'name'))
					end
					if GE_assists == 1 or GE_assists == 3 then
						parse('setmoney '..GE_highest[id]..' '..player(GE_highest[id], 'money') + 150)
					end
				end
				GE_highest[id] = 0
				for i = 1, 32 do
					GE_pldmg[i][id] = 0
				end
			else
				GE_pldmg[source][id] = GE_pldmg[source][id] + hpdmg + apdmg
			end
		end
	end
end

function GE_hudupdate(id, hpdmg)
	if hpdmg then
		d = hpdmg
	else
		d = 0
	end
	local a = (player(id, 'health') - d) / player(id, 'maxhealth')
	local c = a * 255
	local b = 255 - c
	imagescale(GE_bar[id], a, 1)
	imagecolor(GE_bar[id], b, c, 0)
end

function GE_hudsetup(i)
	function hudsetup(id)
		local x = player(id, 'x')
		local y = player(id, 'y')
		if GE_hpbar == 1 then
			q = 132 + id
			r = 0
			s = 1
			t = 0
		elseif GE_hpbar >= 2 then
			q = 1
			if GE_hpbar == 2 then
				r = x + 32
			else
				r = x - 32
			end
			s = y
			t = x
		end
		GE_bar[id] = image(PHB..'Hpbar'..GE_hpbar..'.png', r, s, q)
		GE_overlay[id] = image(PHB..'Overlay'..GE_hpbar..'.png', t, s, q)
		GE_hudupdate(id)
	end
	if i then
		hudsetup(i)
	else
		for z = 1, 32 do
			hudsetup(z)
		end
	end
end

function GE_kill(id, victim, weapon)
	local a = GE_fadetime
	local d = GE_fadesettings
	local f = GE_mode[id]
	local x = GE_diex[victim]
	local y = GE_diey[victim]
	local z = weapon
	if GE_hpbar > 0 then
		freeimage(GE_bar[victim])
		freeimage(GE_overlay[victim])
	end
	if GE_kgore == 1 then
		if z == 34 or z == 35 then
			GE_img[GE_val] = image(P..'S1.png', x, y, 0)
			imagepos(GE_img[GE_val], x, y, player(id,'rot'))
			imagecolor(GE_img[GE_val], math.random(200, 255), 0, 0)
		elseif z == 45 then
			GE_img[GE_val] = image(P..'D4.png', x, y, 0)
			imagepos(GE_img[GE_val], x, y, player(id,'rot'))
			if GE_hitsmoke == 1 then
				if f == 0 then
					parse('effect \"colorsmoke\" '..x..' '..y..' 32 10 0 255 0')
				elseif f == 1 then
					parse('effect \"colorsmoke\" '..x..' '..y..' 32 10 255 0 0')
				elseif f == 2 then
					parse('effect \"colorsmoke\" '..x..' '..y..' 32 10 255 255 0')
				elseif f == 3 then
					parse('effect \"colorsmoke\" '..x..' '..y..' 32 10 0 0 255')
				end
			end
		else
			GE_img[GE_val] = image(P..'D'..math.random(1, 3)..'.png', x, y, 0)
			imagepos(GE_img[GE_val], x, y, math.random(0, 360))
			imagecolor(GE_img[GE_val], math.random(200, 255), 0, 0)
		end
		if d == 2 then
			tween_alpha(GE_img[GE_val], a, 0.0)
			timer(a, 'freeimage', GE_img[GE_val])
		elseif d ~= -1 then
			GE_erase()
		end
		if GE_mgore == 1 then
			GE_randomimg(GE_val, victim)
			GE_randomimg(GE_val, victim)
		end
		if GE_limbs == 1 then
			GE_img[GE_val] = image(P..'P'..math.random(1, 5)..'.png', x, y, 0)
			imagepos(GE_img[GE_val], x + math.random(-16, 0), y + math.random (-16, 16), math.random(0, 360))
			if d == 2 then
				tween_alpha(GE_img[GE_val], a, 0.0)
				timer(a, 'freeimage', GE_img[GE_val])
			elseif d ~= -1 then
				GE_erase()
			end
			GE_img[GE_val] = image(P..'P'..math.random(1, 5)..'.png', x, y, 0)
			imagepos(GE_img[GE_val], x + math.random(0, 16), y + math.random (-16, 16), math.random(0, 360))
			if d == 2 then
				tween_alpha(GE_img[GE_val], a, 0.0)
				timer(a, 'freeimage', GE_img[GE_val])
			elseif d ~= -1 then
				GE_erase()
			end
			GE_img[GE_val] = image(P..'P'..math.random(1, 5)..'.png', x, y, 0)
			imagepos(GE_img[GE_val], x + math.random(-16, 16), y + math.random (-16, 0), math.random(0, 360))
			if d == 2 then
				tween_alpha(GE_img[GE_val], a, 0.0)
				timer(a, 'freeimage', GE_img[GE_val])
			elseif d ~= -1 then
				GE_erase()
			end
			GE_img[GE_val] = image(P..'P6.png', x, y, 0)
			imagepos(GE_img[GE_val], x + math.random(-16, 16), y + math.random (0, 16), math.random(0, 360))
			if d == 2 then
				tween_alpha(GE_img[GE_val], a, 0.0)
				timer(a, 'freeimage', GE_img[GE_val])
			elseif d ~= -1 then
				GE_erase()
			end
		end
	end
	GE_knife[victim] = 0
	freeimage(GE_knifeimg[victim])
end

function GE_move(id, x, y)
	GE_diex[id] = x
	GE_diey[id] = y
	if GE_hpbar > 1 then
		local x = player(id, 'x')
		local y = player(id, 'y')
		if GE_hpbar == 2 then
			xa = x + 32
		elseif GE_hpbar == 3 then
			xa = x - 32
		end
		tween_move(GE_bar[id], 0, xa, y)
		tween_move(GE_overlay[id], 0, x, y)
	end
end

function GE_movetile(id, x, y)
	local a = GE_fadetime
	local d = GE_fadesettings
	local k = GE_diex[id]
	local l = GE_diey[id]
	if player(id, 'health') <= player(id, 'maxhealth') / 3.5 then
		if GE_footerase == 1 then
			GE_img2[GE_foot] = image(P..'T'..math.random(1, 3)..'.png', k, l, 0)
			imagepos(GE_img2[GE_foot], k, l, player(id, 'rot'))
			imagecolor(GE_img2[GE_foot], math.random(200, 255), 0, 0)
			if d == 2 then
				tween_alpha(GE_img2[GE_foot], a, 0.0)
				timer(a, 'freeimage', GE_img2[GE_foot])
			elseif d ~= -1 then
				GE_erase2()
			end
		else
			GE_img[GE_val] = image(P..'T'..math.random(1, 3)..'.png', k, l, 0)
			imagepos(GE_img[GE_val], k, l, player(id, 'rot'))
			imagecolor(GE_img[GE_val], math.random(200, 255), 0, 0)
			if d == 2 then
				tween_alpha(GE_img[GE_val], a, 0.0)
				timer(a, 'freeimage', GE_img[GE_val])
			elseif d ~= -1 then
				GE_erase()
			end
		end
	end
end

function GE_randomimg(Nr, id)
	local a = GE_fadetime
	local d = GE_fadesettings
	local k = GE_diex[id]
	local l = GE_diey[id]
	GE_img[Nr] = image(P..'F'..math.random(1, 4)..'.png', k, l, 0)
	imagepos(GE_img[Nr], k + math.random(-32, 32), l + math.random(-32, 32), math.random(0, 360))
	imagecolor(GE_img[Nr], math.random(200, 255), 0, 0)
	if d == 2 then
		tween_alpha(GE_img[GE_val], a, 0.0)
		timer(a, 'freeimage', GE_img[GE_val])
	elseif d ~= -1 then
		GE_erase()
	end
end

function GE_say(id, message)
	if string.upper(message) == '!ERASE' then
		if GE_contains(GE_admins, player(id, 'usgn')) then
			if GE_saycmds == 1 then
				for i = 0, GE_val do freeimage(GE_img[i]) end
				GE_val = 0
			end
		end
	elseif string.upper(message) == '!HELP' then
		msg2(id, 'Say "!erase" or "!Erase" as admin to erase current gore.')
	end
end

function GE_second()
	if GE_healthflash == 1 then
		for id = 1, 32 do
			if GE_contains(player(0,"tableliving"), id) then
				if player(id, 'health') <= player(id, 'maxhealth') / 3.5 then
					if GE_healthshake == 1 then
						parse('shake '..id..' 5')
					end
					GE_walkflash[id] = image(P..'Flash.png', 320, 240, 2, id)
					imagecolor(GE_walkflash[id], math.random(200, 255), 0, 0)
					imagealpha(GE_walkflash[id], 0.8)
					tween_alpha(GE_walkflash[id], 500, 0.0)
					timer(500, 'freeimage', GE_walkflash[id])
					parse('sv_sound2 '..id..' GoreExtension/Heartbeat.ogg')
				end
			end
		end
	end
end

function GE_select(id, type, mode)
	GE_mode[id] = mode
	GE_knife[id] = 0
	freeimage(GE_knifeimg[id])
	if GE_wornweapons == 1 then
		freeimage(GE_worn1[id])
		freeimage(GE_worn2[id])
		function GE_prim(WID)
			if GE_contains(playerweapons(id), WID) then
				if type ~= WID then
					GE_worn1[id] = image(P..'WW/'..WID..'.png', 1, 0, 200 + id)
				end
			end
		end
		function GE_sec(WID)
			if GE_contains(playerweapons(id), WID) then
				if type ~= WID then
					GE_worn2[id] = image(P..'WW/'..WID..'.png', 1, 0, 100 + id)
				end
			end
		end
		for i = 10, 49 do GE_prim(i) end
		for i = 1 , 6 do GE_sec(i) end
	end
end

function GE_spawn(id)
	if GE_hpbar > 0 then
		GE_hudsetup(id)
	end
end

function GE_startround()
	if GE_wornweapons == 1 then
		for i = 1, 32 do freeimage(GE_worn1[i]) freeimage(GE_worn2[i]) end
	end
end