--	Gore Extension Configuration

--	(made by Alistaire)

--[[

GE_admins:

Table of USGN values allowed to erase the gore on the map.

----------------

GE_assists:

Value for integrated kill assists script.

	GE_assists			Manner

		0		-		No money or message on kill assist

		1		-		Money and message on kill assist

		2		-		Only message on kill assist

		3		-		Only money on kill assist

----------------

GE_attflares:

Switch for added attack flares at guns.

	GE_attflares		Manner

		0		-		No gunflares

		1		-		Gunflares (also at laser)

----------------

GE_fadesettings:

Value for gore fading.

	GE_fadesettings		Manner

	   -1		-		No erasing

		0		-		No fading out

		1		-		Fading on GE_maxval reached

		2		-		Fading over time

*NOTE: GE_FADESETTINGS 2 FADES A BLOODSPLASH ALREADY WHEN IT'S PLACED. GE_FADESETTINGS 1 FADES A LONG TIME AFTER PLACEMENT.

----------------

GE_fadetime:

The ammount of time it takes for gore to fade out.

	GE_fadesettings		GE_fadetime

	   -1		-		x

		0		-		x

		1		-		< 2000

		2		-		> 5000

*NOTE: ONLY WHEN GE_FADESETTINGS > 0!

*NOTE #2: THE TABLE IS JUST A GUIDELINE. X MEANS IT DOESN'T REALLY MATTER AT THAT GE_FADESETTINGS. AT GE_FADESETTINGS OF 1 IT'S BEST TO KEEP GE_FADETIME UNDER 2000, FOR SHORTER FADING.

----------------

GE_footerase:

Switch for a seperate erase rate for bloody footsteps.

	GE_footerase		Manner

		0		-		Footsteps count as normal gore

		1		-		Footsteps count as a seperate value

----------------

GE_footmax:

The ammount of bloody footsteps allowed on the map.

*NOTE: ONLY WHEN GE_FOOTERASE == 1!

----------------

GE_healthflash:

Switch for bloodflashes over time at low health.

	GE_healthflash		Manner

		0		-		No low-health flash

		1		-		Low-health flash

----------------

GE_healthshake:

Switch for heartbeat-like shakes over time at low health.

	GE_healthshake		Manner

		0		-		No low-health shake

		1		-		Low-health shake

----------------

GE_hitshake:

Switch for a shaking screen when you're hit. Shake power depends on gun.

	GE_hitshake			Manner

		0		-		No hitshake

		1		-		Hitshake

----------------

GE_hitsmoke:

Switch for smoke effects on hit.

	GE_hitsmoke			Manner

		0		-		No smoke

		1		-		Red smoke on bullet hit and colored on laser hit

*NOTE: MAY CAUSE MAJOR LAGSPIKES AT HUGE RIFLESPAMS!

----------------

GE_hitsplashes:

Switch for custom hit splashes.

	GE_hitsplashes		Manner

		0		-		No custom hit splashes

		1		-		Custom hitsplashes (also on laser)

----------------

GE_hpbar:

Value for visible HP bar on players

	GE_hpbar			Manner

		0		-		No HP bar

		1		-		HP bar moves from sides to middle

		2		-		HP bar moves from left to right

		3		-		HP bar moves from right to left

*NOTE: THIS FUNCTION MAY CAUSE SERIOUS LAG ISSUES IF GE_HPBAR == 2 OR 3, IF USED WITH MULTIPLE BLOOD SPRITES!

----------------

GE_kgore:

Switch for gore on kill.

	GE_kgore			Manner

		0		-		No gore on kill

		1		-		Gore on kill

*NOTE: THERE IS NO USE IN TURNING THIS OPTION OFF, SINCE THIS IS THE REASON FOR THIS SCRIPT!

----------------

GE_limbs:

Switch for bodyparts on kill.

	GE_limbs			Manner

		0		-		No bodyparts on kill

		1		-		Bodyparts on kill

*NOTE: THIS OPTION ISN'T THAT GRAPHICALLY CHALLENGING AND EVERYTHING JUST LOOKS A BIT BETTER WITH IT!

----------------

GE_maxval:

The ammount of gore allowed on the map.

			Major FPS drops						Minor FPS drops
		Players			GE_maxval			Players			GE_maxval

		8				850					8				500
		12				800					12				450
		16				750					16				450
		20				650					20				400
		24				600					24				350
		28				500					28				350
		32				400					32				300

*NOTE: BEST AMMOUNT OF MAXIMAL GORE ON THE MAP DEPENDS ON PLAYER AMMOUNT!

----------------

GE_mgore:

Switch for extra random gore on hit and kill.

	GE_mgore			Manner

		0		-		No extra gore on hit and kill

		1		-		Extra gore on hit and kill

*NOTE: THIS OPTION IS MAINLY FOR MAKING HITGORE DISAPPEAR SLOWER!

----------------

GE_saycmds:

Switch for say commands (!erase, !help)

	GE_saycmds			Manner

		0		-		Can't erase gore as admin, can't use !help

		1		-		Can erase gore as admin, can use !help

*NOTE: THIS OPTION IS FOR LAG REDUCTION PURPOSES WHEN FADESETTINGS ARE NOT THERE!

----------------

GE_wgore:

Switch for gore on walls on hit.

	GE_mgore			Manner

		0		-		No gore on walls

		1		-		Gore on walls

*NOTE: GE_WGORE SPRITES ARE TREATED LIKE NORMAL BLOODSPRITES, AND GET ERASED WHEN MAXIMUM GORE AMMOUNT IS REACHED!

----------------

GE_wornweapons:

Switch for integrated wornweapons mod.

	GE_wornweapons		Manner

		0		-		No weapons worn on back

		1		-		Weapons worn on back

*NOTE: STILL IN BETA, THE SCRIPT IS NOT REALLY MULTIPLAYER-COMPATIBLE!

----------------

GE_wpnshake:

Switch for weaponshake on low health.

	GE_wpnshake			Manner

		0		-		No weaponshake on low health

		1		-		Weaponshake on low health

--]]

GE_admins = {21737}

GE_assists = 1

GE_attflares = 1

GE_fadesettings = 1

GE_fadetime = 500

GE_footerase = 1

GE_footmax = 100

GE_healthflash = 1

GE_healthshake = 1

GE_hitshake = 1

GE_hitsmoke = 1

GE_hitsplashes = 1

GE_hpbar = 2

GE_kgore = 1

GE_limbs = 1

GE_maxval = 500

GE_mgore = 1

GE_saycmds = 1

GE_wgore = 1

GE_wornweapons = 0

GE_wpnshake = 1